#ifndef CWADLIB_INCLUDED
#define CWADLIB_INCLUDED

#include <windows.h>

#ifndef CWAD_STATIC

#ifdef CWADLIB_EXPORTS
#define CWADAPI __declspec(dllexport)
#else
#define CWADAPI __declspec(dllimport)
#endif

#else
#define CWADAPI
#endif

#define CWAD_INFO_NUM_FILES       0x03 //Number of files in CWAD
#define CWAD_INFO_TYPE            0x04 //Is HANDLE a file or a CWAD?
#define CWAD_INFO_SIZE            0x05 //Size of CWAD or uncompressed file
#define CWAD_INFO_COMPRESSED_SIZE 0x06 //Size of compressed file
#define CWAD_INFO_FLAGS           0x07 //File flags (compressed, etc.)
#define CWAD_INFO_PARENT          0x08 //Handle of CWAD that file is in
#define CWAD_INFO_POSITION        0x09 //Position of file pointer in files
#define CWAD_INFO_PRIORITY        0x0B //Priority of open CWAD

#define CWAD_TYPE_CWAD 0x01
#define CWAD_TYPE_FILE 0x02

#define CWAD_SEARCH_CURRENT_ONLY 0x00 //Used with CWadOpenFile; only the archive with the handle specified will be searched for the file
#define CWAD_SEARCH_ALL_OPEN     0x01 //CWadOpenFile will look through all open archives for the file

BOOL  CWADAPI WINAPI CWadOpenArchive(LPCSTR lpFileName, DWORD dwPriority, HANDLE *hCWAD);
BOOL  CWADAPI WINAPI CWadCloseArchive(HANDLE hCWAD);
DWORD CWADAPI WINAPI CWadListFiles(HANDLE hCWAD, LPSTR lpBuffer, DWORD dwBufferLength); // Returns required buffer size.  Strings are in multi string form. (null-terminated strings with an extra null after the last string)
BOOL  CWADAPI WINAPI CWadOpenFile(HANDLE hCWAD, LPCSTR lpFileName, DWORD dwSearchScope, HANDLE *hFile);
BOOL  CWADAPI WINAPI CWadCloseFile(HANDLE hFile);
DWORD CWADAPI WINAPI CWadGetFileSize(HANDLE hFile);
DWORD CWADAPI WINAPI CWadGetFileInfo(HANDLE hFile, DWORD dwInfoType);
DWORD CWADAPI WINAPI CWadSetFilePointer(HANDLE hFile, long lDistanceToMove, DWORD dwMoveMethod);
BOOL  CWADAPI WINAPI CWadReadFile(HANDLE hFile, LPVOID lpBuffer, DWORD nNumberOfBytesToRead, LPDWORD lpNumberOfBytesRead);
BOOL  CWADAPI WINAPI CWadSetArchivePriority(HANDLE hCWAD, DWORD dwPriority);
DWORD CWADAPI WINAPI CWadFindHeader(HANDLE hFile);

#endif

